package		CopyMe;
require		Exporter;
require		CopyMeBasic;
@ISA =		qw(CopyMeBasic);
@EXPORT =	qw(copy_of);

# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

# perl has references, not pointers, and all objects are (blessed)
# references, so there isn't really any distinction between copy_of and
# a copy constructor.  What this package provides is a default copy
# constructor called copy_of for any class whose underlying reference is
# a hash variable whose values are either simple data members to be
# copied literally or references to objects with their own correct
# copy_of members.  If not, the inheriting class 
# must override copy_of.

sub copy_of {
# medium-dumb copy constructor
  my $self = shift;
  # if called with an object reference, type will be set to its type and
  # new will attempt to behave as a copy constructor.  Otherwise, new
  # will assume that its first argument is a class name
  my $type = ref( $self);
  if ( $type) {
#  this is bad: it creates a new reference to the same anonymous hash,
#  instead of copying it to a new hash and returning a new reference to
#  it.
#     my $other = $self; # dumb copy
    my $other = {};

    foreach $key (keys (%$self)) {
      if ( ref( $self->{$key})) {
        $other->{$key} = $self->{$key}->copy_of();
      } else {
        $other->{$key} = $self->{$key};
      }
    }

    return (bless $other, $type);
#     return bless $other, $type;
  }
  return undef;
}

