package		CopyMeBasic;
require		Exporter;
@ISA =		qw(Exporter);
@EXPORT =	qw(copy_of);

# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.


# perl has references, not pointers, and all objects are (blessed)
# references, so there isn't really any distinction between copy_of and
# a copy constructor.  What this package provides is a default copy
# constructor called copy_of for any class whose underlying reference is
# a hash variable.  If not, or if the hash contains
# values with non-trivial copy constructors, the inheriting class 
# must override copy_of.

#  for a somewhat more sophisticated default version which calls copy_of
#  recursively on all references, see CopyMe

sub copy_of {
# dumb copy constructor
# any a non-hash reference, or no default new constructor, or hash
# values with non-trivial copy constructors, must override this
  my $self = shift;
  # if called with an object reference, type will be set to its type and
  # new will attempt to behave as a copy constructor.  Otherwise, new
  # will assume that its first argument is a class name
  my $type = ref( $self);
  if ( $type) {
#  this is bad: it creates a new reference to the same anonymous hash,
#  instead of copying it to a new hash and returning a new reference to
#  it.
#     my $other = $self; # dumb copy
    my %other = %$self;
    return (bless \%other, $type);
#     return bless $other, $type;
  }
  return undef;
}

