package		NatLatexParagraph;
require		Exporter;
use		MakeParagraph();
use		OutFile ();
@ISA =		qw(MakeParagraph);
@EXPORT =	qw(new ignore leave leave_space math_append
		white_space_after_most_math flush_paragraph);

use strict;
use English;
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

sub new {
  my $invoked = shift;
  my $type = ref( $invoked) || $invoked;
  my $ignore = shift;
  my $self = new MakeParagraph (@_);
  if ( ref( $self)) {
    #  valid reference returned by MakeParagraph::new, so bless it as type
    #  (either NatLatexParagraph or a descendant) and then do our initialization
    bless $self, $type;
    my $ok;
    $ok = $self->_initialize($ignore);
    if ( $ok) {
      return $self;
    }
  }
  return $self;
}

sub _initialize {
  my $self = shift;
  my $ignore = shift;
  $self->{"ignore"} = $ignore;
  return 1;
}

sub ignore {
  my $self = shift;
  my $ignore = shift;
  if ( defined($ignore)) {
    $self->{"ignore"} = $ignore;
  }
  return $self->{"ignore"};
}

sub leave_space {
  my $self = shift;
  my $term = shift;
  if ( ! $self->ignore()) {
    $self->_leave($term);
  } else {
    $self->_leave(" ");
  }
  return;
}

sub leave {
  my $self = shift;
  my $additional = shift;
  if ( ! $self->ignore()) {
    $self->_leave($additional);
  }
  return;
}

sub _leave {
  my $self = shift;
  my $additional = shift;
  $self->append($additional);
  return;
}

sub math_append {
  my $self = shift;
  my $additional = shift;
  #  adds white space if necessary (not if already present or following
  #  certain punctuation like ", (, [, {.
  $self->white_space_after_most_math();
  $additional =~ s/^ +//;
#   }
#   if ($self->white_space_after_most()) {
#     $additional =~ s/^ +//;
#   }
  $self->append($additional);
  return;
}


sub flush_paragraph {
  my $self = shift;
  my ($output_file_ref, $new_lines) = @_;
  my $term = "\n\n";
  if ( defined($new_lines) ) {
    $term = "\n" x $new_lines;
  }
  if ( ! ($self->empty())) {
    my $s = $self->string();
    $s =~ s/ $//;
    $output_file_ref->print($s);
    $output_file_ref->print($term);
    $self->clear();
  }
}

sub white_space_after_most_math {
#  append white space (or any other character) as long as the previous
#  character is not itself white space, or ",
#  otherwise do nothing
  my $self = shift;
  my $additional = shift;
  if (  !(defined($additional))) {
    $additional = " "; #  default is a single space
  }
  if ( $self->empty()) {
    return 0;
  }
  if ( $self->string() =~ /[\s\"]$/) {
    return 0;
  }
  $self->append($additional);
  return 1;
}
