package		QuoteMe;
require		Exporter;
@ISA =		qw(Exporter);
@EXPORT =	qw(new return_quoted by_name by_character 
		name_of character_string character_named);
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

use strict;
use English;

#  pass a reference to a hash from names to characters to the new
#  subroutine
sub new {
  my $self = shift;
  my $type = ref( $self);
  if ( $type) {
    my %other = $$self;
    return (bless \%other, $type);
  }
  $type = $self;
  $self = {};
  bless $self, $type;
#   print "QuoteMe::new\n";
  $self->_initialize(@_);
  return $self;
}

sub _initialize {
  my $self = shift;
  my $hash_reference = shift;
#   print "QuoteMe::_initialize\n";
#   print "]" . ref( $hash_reference). "[\n";
#   print "QuoteMe::_initialize\n";
  if ( ref( $hash_reference) =~ /^HASH/ ) {
    my %h = %{$hash_reference};
#     print "QuoteMe::_initialize: reference ok \n";
    $self->{"by name"} =  \%h;
    my %r = reverse %h;
    $self->{"by character"} = \%r;
    return 1;
  } else {
    return 0;
  }
}

sub return_quoted {
  my $self = shift;
  my @characters = @_;
  if ( $#characters == 0) {
    return "\Q$characters[0]\E";
  } else {
    return map("\Q$_\E", @characters);
  }
}

sub by_character {
  my $self = shift;
  my $character = shift;
  if ( !defined($character)) {
    return values(%{$self->{"by character"}});
  }
  return $self->{"by character"}{$character};
}

sub by_name {
  my $self = shift;
  my $name = shift;
  if ( !defined($name)) {
    return values(%{$self->{"by name"}});
  }
  return $self->{"by name"}{$name};
}

sub character_string {
  my $self = shift;
  my @names = @_;
  if ( $#names == -1) {
    @names = $self->by_character();
  }
  my $string = "";
  foreach (@names) {
    $string .= $self->by_name($_);
  }
  return "\Q$string\E";
}

sub character_named {
  my $self = shift;
  my @names = @_;
  if ( $#names == 0) {
    return $self->return_quoted($self->by_name($names[0]));
  } else {
    return map($self->return_quoted($self->by_name($_)), @names);
  }
}

sub name_of {
  my $self = shift;
  my @characters = @_;
  if ( $#characters == 0) {
    return $self->by_character($characters[0]);
  } else {
    return map($self->by_character($_), @characters);
  }
}

