package		ScanErrors;
require		Exporter;
@ISA =		qw(Exporter);
@EXPORT =	qw(print_hash ErrorReading WarningProcessing ErrorProcessing);
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.


use strict;
use English;

use ScanByLine ();
use MakeParagraph ();
use not_dead_yet;

#############################
# error reporting/diagnostics
#############################

sub print_hash {
  my $h = shift;
  foreach (keys(%$h)) {
    print $_, " => ", $h->{$_}, "\n";
  }
}

sub ErrorReading {
  my ( $input_file_ref) = @_;
  print "\non line ", $input_file_ref->line_number();
  print " of file ", $input_file_ref->name(), "\n";
  die_slowly();
}

sub WarningProcessing {
  my ( $input_file_ref, $paragraph_ref) = @_;
  print "\non line ", $input_file_ref->line_number();
  print " of file ", $input_file_ref->name(), "\n";
  print "while processing paragraph:\n";
  print $paragraph_ref->format();
  print "\n";
}

sub ErrorProcessing {
  my ( $input_file_ref, $paragraph_ref) = @_;
  if ( !defined($paragraph_ref)) {
    ErrorReading($input_file_ref);
  }
  WarningProcessing( $input_file_ref, $paragraph_ref);
  die_slowly();
}

