package		ScanLatex;
require		Exporter;
use		ScanByLine ();
use		LatexSpecial ();
use		EquationSpecial ();
@ISA =		qw(ScanByLine);
@EXPORT =	qw(new specials equation_specials eat_to_equation_special
		latex_specials eat_to_latex_special
		eat_to_named eat_to_end_of_block);
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

use strict;
use English;
# use LatexSpecial;

sub new {
  my $invoked = shift;
  my $type = ref( $invoked) || $invoked;
  #  call the ScanByLine constructor first
  #  it will run its own initialization routine
  my $self = new ScanByLine (@_);
  my $ok;
  if ( ref( $self)) {
    #  valid reference returned by ScanByLine::new, so bless it as type
    #  (either ScanLatex or a descendant) and then do our initialization
    bless $self, $type;
    $ok = $self->_initialize();
    if ( $ok) {
      return $self;
    }
    return  $self->error();
  }
  return $self; #  should contain error
}

sub _initialize {
  my $self = shift;
  $self->{"latex special"} = new LatexSpecial();
  $self->{"equation special"} = new EquationSpecial();
  return 1;
}

sub specials {
  my $self = shift;
  return $self->latex_specials();
}

sub latex_specials {
  my $self = shift;
  return $self->{"latex special"};
}

sub equation_specials {
  my $self = shift;
  return $self->{"equation special"};
}

sub eat_to_named {
  my $self = shift;
  my @names = @_;
  my @value = $self->eat_to_special(
      $self->equation_specials()->character_string(@names));
  return @value;
}


sub eat_to_equation_special {
  my $self = shift;
  my @value = $self->eat_to_special(
  $self->equation_specials()->character_string());
  return @value;
}

sub eat_to_latex_special {
  my $self = shift;
#   print "<", $self->latex_specials()->character_string(), ">\n";
  my @value = $self->eat_to_special(
  $self->latex_specials()->character_string());
  return @value;
}

#  always need to allow for macros, because "}" or "$" could be escaped
#  in principle, we really ought to allow for comments, since in theory,
#  someone could write:
# $x = y + %x differs from y because of deflection
#    + m(x)$

sub eat_to_end_of_block {
  my $self = shift;
  my @value = $self->eat_to_special($self->{"latex special"}{"end block"});
  return @value;
}


