package		ScanNLX;
require		Exporter;
use		ScanByLine ();
use		NLXSpecial ();
@ISA =		qw(ScanByLine);
@EXPORT =	qw(new specials NLX_specials eat_to_NLX_special
		eat_to_named eat_to_end_of_block);
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

use strict;
use English;
# use LatexSpecial;

sub new {
  my $invoked = shift;
  my $type = ref( $invoked) || $invoked;
  #  call the ScanByLine constructor first
  #  it will run its own initialization routine
  my $self = new ScanByLine (@_);
  my $ok;
  if ( ref( $self)) {
    #  valid reference returned by ScanByLine::new, so bless it as type
    #  (either ScanNLX or a descendant) and then do our initialization
    bless $self, $type;
    $ok = $self->_initialize();
    if ( $ok) {
      return $self;
    }
    return  $self->error();
  }
  return $self; #  should contain error
}

sub _initialize {
  my $self = shift;
  $self->{"NLX special"} = new NLXSpecial();
  return 1;
}

sub specials {
  my $self = shift;
  return $self->NLX_specials();
}

sub NLX_specials {
  my $self = shift;
  return $self->{"NLX special"};
}

sub eat_to_named {
  my $self = shift;
  my @names = @_;
  my @value = $self->eat_to_special(
      $self->NLX_specials()->character_string(@names));
  return @value;
}


sub eat_to_NLX_special {
  my $self = shift;
#   print "<", $self->NLX_specials()->character_string(), ">\n";
  my @value = $self->eat_to_special(
  $self->NLX_specials()->character_string());
  return @value;
}

sub eat_to_end_of_block {
  my $self = shift;
  my @value = $self->eat_to_special($self->{"NLX special"}{"end block"});
  return @value;
}


