package		t2lRead;
require		Exporter;
use		l2tRead;
@ISA =		qw(Exporter);
@EXPORT =	qw(ReadCommandLine ReadTranslations);
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

use strict;
use English;
use ScanLatex ();
use LatexSpecial ();
use NatLatexParagraph ();
use OutFile ();

use ScanErrors;
use CurrentParagraph;
use newParseLatex;

use WinWait;
use not_dead_yet;

#############################
# reading configuration files
#############################

sub ReadCommandLine { # (\%command_line_options)
# filename = ReadCommandLine(\%command_line_options);
  my $options_ref = shift;

  my $input_filename = "";
  my $argument;
  my $usage = "Usage: t2l filename.txt";
  my $error = 0;
  foreach $argument (@ARGV) {
    if ( $argument =~ s/^-ignore$//) {
      $options_ref->{"ignore"} = 1;
    } elsif ( $argument =~ s/^-//) {
      print "unknown option $argument\n";
      $error = 1;
      last;
    } else {
      $input_filename = $argument;
      last;
    }
  }
  if ( $input_filename ne "") {
    return $input_filename;
  }
  if ( !($error)) {
    print "missing filename\n";
  }
  die_slowly("$usage");
}



#############################
# reading configuration files
#############################

sub ReadTranslations {
  my ( $filename, $directive_marker, $macro_tables) = @_;

  my $file_ref = new ScanLatex($filename);
  ref( $file_ref)  or die_slowly( $file_ref);
  my $special = new LatexSpecial;

  my $translation;
  my $value;
  my $replacement;

  while ( !( $file_ref->eof())) {
    $file_ref->getline();
    $translation = ReadDispositionReplace($file_ref, $special);
    $replacement = ReadDispositionReplace($file_ref, $special);
    $value = ValidTranslation($translation, $replacement, $macro_tables);
    if ( ! ($value)) {
      print "in replacement text $translation\n";
      ErrorReading($file_ref);
    }
  }
}
