#!/opt/bin/perl -w
# (C) 1999 David C. Fox
# This code may be freely reproduced and modified, provided 
# 1. This copyright notice is retained, 
# and
# 2. substantial modifications are indicated, together with the author's
# name, in any redistributed versions.

use English;


##################################################
# main routine
##################################################

my $directive_marker = "\Q\%NLX\%\E";

my $input_filename;
my %command_line_options;



my $line;
my $paragraph;


while ($line = <STDIN>) {
    chomp($line);
    if ($line =~ /^\s*$/) {
        if ($paragraph) {
            print $paragraph;
            print "\n";
        }
        print $line;
        print "\n\n";
        $paragraph = "";
    }
    if ($line =~ /^$directive_marker/ && $paragraph) {
        print $paragraph;
        print "\n";
        print $line;
        print "\n";
        $paragraph = "";
    } else {
        if ($paragraph) {
            $paragraph .= ' ';
        }
        $paragraph .= $line;
        if ($line =~ /^%/  || $line =~ /[^\\]%/) {
            print $paragraph;
            print "\n";
            $paragraph = "";
        }
    }
}

if ($paragraph) {
  print $paragraph;
  print "\n";
}

